/*!
 * MindPlus
 * uno
 *
 */
#include<DFRobot_ASR.h>
#include <DFRobot_RGBPanel.h>
#include <DFRobot_Libraries.h>
#include<DFRobot_SpeechSynthesis.h>

// 动态变量
volatile float question_number, answer_number;
int insertNum = 0;
float used[16]={};

// 函数声明
void(* resetFunc) (void) = 0;

// 静态常量
const uint16_t bitmap[][8] = {
    {0x03c0,0x07e0,0x0660,0x0660,0x00c0,0x0180,0x0000,0x0180},
    {0x0000,0x1008,0x2814,0x2814,0x2814,0x0000,0x0ff0,0x1008}
};

// 创建对象
DFRobot_SpeechSynthesis_I2C sstts;
DFRobot_ASR                 asr;
DFRobot_RGBPanel            panel;


// 主程序开始
void setup() {
    dfrobotRandomSeed();
    sstts.begin();
    sstts.setVoice(10);
    sstts.setSpeed(4);
    sstts.setSoundType(sstts.FEMALE1);
    sstts.setTone(5);
    asr.begin(LOOP,MIC);
    asr.addCommand("chong fu",0);   //重复当前谜面
    asr.addCommand("lin",1);
    asr.addCommand("deng long",2);
    asr.addCommand("huo guo",3);
    asr.addCommand("tang yuan",4);
    asr.addCommand("li zhi",5);
    asr.addCommand("dui bu qi",6);
    asr.addCommand("wu",7);
    asr.addCommand("dui niu tan qin",8);
    asr.addCommand("niu",9);
    asr.addCommand("luo",10);
    asr.addCommand("wen du ji",11);
    asr.addCommand("gao",12);
    asr.addCommand("yi shi ban hui",13);
    asr.addCommand("xia luo bu ming",14);
    asr.addCommand("pang",15);
    asr.addCommand("qian niu zi",16);
    asr.addCommand("xia yi ge",17);   //下一个谜语
    asr.start();
    delay(1000);
    
    sstts.speak(F("去年元夜时，花市灯如昼。"));
}
void loop() {
    panel.diy(bitmap[0], 10);
    question_number = (random(1, 16+1));
    answer_number = -1;
    for(int i=0;i<16;i++){
        if(used[i]==question_number){
            return;
        }
    }
    used[insertNum] = question_number;
    insertNum+=1;
    if(insertNum>=12){
        insertNum=0;
        memset(used,0,16);
        return;
    }
    if ((question_number==1)) {
        sstts.speak(F("请听题。年终岁尾，不缺鱼米，打一个字。"));
        while (1) {
            delay(0.1);
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("年终岁尾，不缺鱼米，打一个字。"));
            }
            else if ((answer_number==1)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，鱼鳞的鳞字。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==2)) {
        sstts.speak(F("请听题。一只罐，两个口，只装火，不装酒，打一日常用品。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("一只罐，两个口，只装火，不装酒，打一日常用品。"));
            }
            else if ((answer_number==2)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，灯笼。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==3)) {
        sstts.speak(F("中间是火山，四边是大海。海里宝贝多，快快捞上来。打一日常用品。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("中间是火山，四边是大海。海里宝贝多，快快捞上来。打一日常用品。"));
            }
            else if ((answer_number==3)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，火锅。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==4)) {
        sstts.speak(F("请听题。白白身子圆溜溜，样子像个乒乓球，放在锅里煮一煮，全家吃它过十五。打一种食物。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("白白身子圆溜溜，样子像个乒乓球，放在锅里煮一煮，全家吃它过十五。打一种食物。"));
            }
            else if ((answer_number==4)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，汤圆。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==5)) {
        sstts.speak(F("请听题。红关公，白刘备，黑张飞，叁结义。打一种水果。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("红关公，白刘备，黑张飞，叁结义。打一种水果。"));
            }
            else if ((answer_number==5)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，荔枝。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==6)) {
        sstts.speak(F("请听题。下联难配上联。打三字礼貌用语。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("下联难配上联。打三字礼貌用语。"));
            }
            else if ((answer_number==6)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，对不起。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==7)) {
        sstts.speak(F("请听题。远看一头牛，近看没有头，打一个字。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("远看一头牛，近看没有头，打一个字。"));
            }
            else if ((answer_number==7)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，午。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==8)) {
        sstts.speak(F("请听题。牧童玩吉他，打一成语。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("牧童玩吉他，打一成语。"));
            }
            else if ((answer_number==8)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，对牛弹琴"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==9)) {
        sstts.speak(F("请听题。任劳又任怨，田里活猛干，生产万吨粮，只把草当饭。打一种动物。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("任劳又任怨，田里活猛干，生产万吨粮，只把草当饭。打一种动物。"));
            }
            else if ((answer_number==9)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，牛。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==10)) {
        sstts.speak(F("请听题。路边有水，适合种草，打一个字。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("路边有水，适合种草，打一个字。"));
            }
            else if ((answer_number==10)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，落下的落字。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==11)) {
        sstts.speak(F("请听题。小小东西，放在腋底。有病没病，看它肚皮。打一日常用品。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("小小东西，放在腋底。有病没病，看它肚皮。打一日常用品。"));
            }
            else if ((answer_number==11)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，温度计。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==12)) {
        sstts.speak(F("请听题。一口吃掉牛尾巴，打一个字。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("一口吃掉牛尾巴，打一个字。"));
            }
            else if ((answer_number==12)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是告诉的告字。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==13)) {
        sstts.speak(F("请听题。九十分钟后见面，打四字常言。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("九十分钟后见面，打四字常言。"));
            }
            else if ((answer_number==13)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，一时半会"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==14)) {
        sstts.speak(F("请听题。棋子放哪里？打一成语。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("棋子放哪里？打一成语。"));
            }
            else if ((answer_number==14)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，下落不明。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==15)) {
        sstts.speak(F("请听题。明月伴人游。打一个字。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("明月伴人游。打一个字。"));
            }
            else if ((answer_number==15)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，肥胖的胖字。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
    else if ((question_number==16)) {
        sstts.speak(F("请听题。连累了红孩儿。打三字中药名。"));
        while (1) {
            answer_number = (asr.read());
            if ((answer_number==0)) {
                sstts.speak(F("连累了红孩儿。打三字中药名。"));
            }
            else if ((answer_number==16)) {
                panel.diy(bitmap[1], 2);
                sstts.speak(F("答对了，是，牵牛子。"));
                delay(3000);
                break;
            }
            else if ((answer_number==17)) {
                panel.diy(bitmap[1], 2);
                break;
            }
        }
    }
}
